% Set of macros for making index of a book

% This file is public domain.

\newwrite\indexfile%
\immediate\openout\indexfile=\jobname.idx %

\def\gobble#1{}%

\edef\allindex{}%

\def\indexa#1{\indexat{#1}{#1}}%

\long\def\indexat#1#2{{%
  \expandafter\ifx\csname index:#1\endcsname\relax%
    \let\indexnum\relax%
    \edef\thisindexnum{}%
    \def\next##1{%
      \if*##1%
        \let\next\relax%
        \loop\ifnum\count9<14348906 %
          \multiply\count9 by 27 %
        \repeat%
        \edef\thisindexnum{\thisindexnum\indexnum{\the\count9}}%
      \else%
        \ifnum\uccode`##1>0 %
          \ifnum\count9>14348906 %
            \edef\thisindexnum{\thisindexnum\indexnum{\the\count9}}%
            \count9=0 %
          \fi %
          \multiply\count9 by 27 %
          \advance\count9 by \uccode`##1%
          \advance\count9 by -64 %
        \fi%
      \fi%
      \next%
    }%
    \count9=0 \next#1*%
    \global\expandafter\let\csname index:#1\endcsname\thisindexnum%
    \edef\preindex{}%
    \let\postindex\allindex%
    \def\indexnum##1{%
      \count\count9=##1 %
      \advance\count9 by 1 %
      \if\count9=9 \let\indexnum\gobble\fi%
    }%
    \count9=0 \thisindexnum%
    \def\temporary##1{%
      \ifnum##1>\count\count9 %
        \def\next####1{%
          \expandafter\ifx\csname index:####1\endcsname\relax%
            \let\next\relax%
          \fi%
          \next%
        }%
        \xdef\allindex{\preindex{#1}\postindex}%
        \let\indexnum\gobble%
      \else%
        \ifnum##1<\count\count9 \let\indexnum\gobble\fi%
      \fi%
      \advance\count9 by 1 %
      \if\count9=9 \let\indexnum\gobble\fi%
    }%
    \def\next##1{%
      \expandafter\ifx\csname index:##1\endcsname\relax%
        \let\next\relax%
        \xdef\allindex{\preindex{#1}}%
      \else%
        \count0=0 \count1=0 \count2=0 \count3=0 \count4=0 %
        \count5=0 \count6=0 \count7=0 \count8=0 \count9=0 %
        \let\indexnum\temporary \csname index:##1\endcsname%
      \fi%
      \edef\preindex{\preindex{##1}}%
      \edef\postindex{\expandafter\gobble\postindex\empty}%
      \next%
    }%
    \expandafter\next\allindex{}%
  \fi%
  \let\indexentry\relax%
  \expandafter\gdef\csname Index:#1\endcsname{#2}%
  \write\indexfile{\noexpand\indexentry{#1}{\the\pageno}}%
}}%

\long\def\eindexat#1#2{\edef\next{\noexpand\indexat{#1}{#2}}\next}%

\def\indexmo#1#2{{%
  \let\indexnum\relax%
  \def~##1/{\indexnum{##1}}%
  \expandafter\xdef\csname index:#1\endcsname{#2}%
}}%

\def\indexshow#1{\expandafter\show\csname index:#1\endcsname}%

\def\indexentry#1#2{%
  \expandafter\xdef\csname index:#1\endcsname{%
    \csname index:#1\endcsname%
    \indexpage{#2}%
  }%
  \ignorespaces%
}%

\def\makeindex{{%
  \par%
  \immediate\closeout\indexfile%
  \let\indexnum\gobble%
  \let\indexpage\relax%
  \input \jobname.idx %
  \def\indexpage##1{%
    \ifnum\count9=##1 \else%
      \ifnum\count9>0 ,\fi%
      \space##1%
      \count9=##1 %
    \fi%
  }%
  \setbox0=\vbox{%
    \parindent=-0.25in %
    \leftskip=0.25in %
    \rightskip=0.15in %
    \parskip=0pt %
    \divide\hsize by 2 %
    \long\def\next##1{%
      \expandafter\ifx\csname index:##1\endcsname\relax%
        \let\next\relax%
      \else%
        \indent \csname Index:##1\endcsname :%
        \count9=0 \csname index:##1\endcsname.\par%
      \fi%
      \next%
    }%
    \expandafter\next\allindex{}%
    \vfil%
  }%
  \dimen0=\dp0 %
  \advance\dimen0 by \dp0 %
  \ht0=\dimen0 %
  \dp0=0pt %
  \splitmaxdepth=0pt %
  \loop%
    \hbox{}\hrule height 0pt depth 0pt %
    \dimen0=\pagegoal%
    \advance\dimen0 by -\pagetotal %
    \setbox1=\vsplit0 to \dimen0 %
    \setbox2=\vsplit0 to \dimen0 %
    \hbox{\box1\box2}%
    \vfil\eject%
  \ifdim\ht0>0pt \repeat%
}}%
